import java.io.*;
import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: k.rafati
 * Date: Oct 31, 2003
 * Time: 10:59:53 AM
 * To change this template use Options | File Templates.
 */
public class TreeMaker {
    private Tree mytree;
    private ArrayList bytes;
    private ArrayList mysymbols;
    private int symnum;

    public int getSymnum(){
        return symnum;
    }

    public ArrayList getMysymbols() {
        return mysymbols;
    }

    public Tree getTree(){
        return mytree;
    }

    private TwoInts findTwoMin(){
        int temp, first = 0, second = 1;

        if(  ((MergeArrayCell)bytes.get(0)).count > ((MergeArrayCell)bytes.get(1)).count)
            temp = ((MergeArrayCell)bytes.get(0)).count;
        else
            temp = ((MergeArrayCell)bytes.get(1)).count;

        for(int i = 2; i < bytes.size(); i++){
            if( ((MergeArrayCell)bytes.get(i)).count < temp){

                if( ((MergeArrayCell)bytes.get(first)).count < ((MergeArrayCell)bytes.get(second)).count)
                {
                    second = i;

                    if( ((MergeArrayCell)bytes.get(first)).count > ((MergeArrayCell)bytes.get(second)).count)
                        temp = ((MergeArrayCell)bytes.get(first)).count;
                    else
                        temp = ((MergeArrayCell)bytes.get(second)).count;
                }
                else
                {
                    first = i;

                    if( ((MergeArrayCell)bytes.get(first)).count > ((MergeArrayCell)bytes.get(second)).count)
                        temp = ((MergeArrayCell)bytes.get(first)).count;
                    else
                        temp = ((MergeArrayCell)bytes.get(second)).count;
                }
            }
        }

        return new TwoInts( first, second);
    }

    public TreeMaker( RandomAccessFile inputfile){
        bytes = new ArrayList( 256);

        for( int i = 0; i < 256;i++ )
              bytes.add( i, new MergeArrayCell( (byte)i));

        try{
            for( int i = 0; i < inputfile.length();i++ )
                ((MergeArrayCell)bytes.get(inputfile.read())).count += 1;

        }catch(FileNotFoundException e){
        }catch(IOException e){}

        for( int i = 0; i < bytes.size();i++ )
             if( ((MergeArrayCell)bytes.get(i)).count == 0)
                 bytes.remove( i--);

        symnum = bytes.size();

        arrayToTree();
        makesymbols();
    }

    private void makesymbols() {
        mysymbols = new ArrayList();
        mytree.makeSymTab( mysymbols);
    }

    private void arrayToTree(){
        //Exceptions
        if( bytes.size() == 0){
            mytree = null;
            return;
        }

        if( bytes.size() == 1){
            mytree = new Tree( ((MergeArrayCell)bytes.get(0)).mynode);
            return;
        }

        if( bytes.size() == 2){
            Node naeem = new Node( (byte)0);
            naeem.setLeft( ((MergeArrayCell)bytes.get(0)).mynode);
            naeem.setRight( ((MergeArrayCell)bytes.get(1)).mynode);
            mytree = new Tree( naeem);
            return;
        }

        int first, second;
        TwoInts tempol;

        while( bytes.size() != 1){
            tempol = findTwoMin();
            first = tempol.getFirst();
            second = tempol.getSecond();

            Node naeem = new Node( (byte)0);
            naeem.setLeft( ((MergeArrayCell)bytes.get( first)).mynode);
            naeem.setRight( ((MergeArrayCell)bytes.get( second)).mynode);
            ((MergeArrayCell)bytes.get( first)).count += ((MergeArrayCell)bytes.get( second)).count;
            ((MergeArrayCell)bytes.get( first)).mynode = naeem;
            bytes.remove( second);
        }

        mytree = new Tree( ((MergeArrayCell)bytes.get(0)).mynode);
    }
}
